from setuptools import setup

setup(name='megacom',
      version='0.1',
      description='Alternative console-based UART client',
      url='https://awoo.systems',
      author='haskal',
      author_email='haskal@awoo.systems',
      license='AGPLv3',
      packages=['megacom'],
      install_requires=[
            "pyserial-asyncio"
      ],
      include_package_data=True,
      entry_points={
          'console_scripts': [
              "megacom=megacom:main"
          ]
      },
      zip_safe=False)
